"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyMiddleware = void 0;
const utils_1 = require("./utils");
function applyMiddleware(handlers, ...middlewareMaps) {
    return middlewareMaps.reduceRight((prevHandlers, middlewareMap) => {
        return utils_1.mapOperationHandlers(prevHandlers, (handler, handlerInfo) => (parameters, body, context, info) => __awaiter(this, void 0, void 0, function* () {
            var _a, _b, _c;
            let middleware;
            if (typeof middlewareMap === 'function') {
                middleware = middlewareMap;
            }
            else if (handlerInfo === 'default') {
                middleware = middlewareMap.default;
            }
            else {
                // let's try to find if this handler have a
                // correspondance in middleware map either
                // by `operationId` or by path/method
                if (info.operationObject.operationId !== undefined) {
                    middleware = (_a = middlewareMap.operations) === null || _a === void 0 ? void 0 : _a[info.operationObject.operationId];
                }
                if (middleware === undefined) {
                    middleware = (_c = (_b = middlewareMap.paths) === null || _b === void 0 ? void 0 : _b[info.path]) === null || _c === void 0 ? void 0 : _c[info.executionRequest.method];
                }
            }
            if (middleware !== undefined) {
                return yield middleware(handler, parameters, body, context, info);
            }
            else {
                return yield handler(parameters, body, context, info);
            }
        }));
    }, handlers);
}
exports.applyMiddleware = applyMiddleware;
//# sourceMappingURL=middleware.js.map