"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapOperationHandlers = void 0;
function mapOperationHandlers(handlers, mapFunction) {
    var _a;
    let newHandlers = {};
    if (handlers.operations !== undefined) {
        for (const [operationId, handler] of Object.entries(handlers.operations)) {
            const newHandler = mapFunction(handler, { operationId });
            if (newHandler !== undefined) {
                newHandlers = Object.assign(Object.assign({}, newHandlers), { operations: Object.assign(Object.assign({}, newHandlers.operations), { [operationId]: newHandler }) });
            }
        }
    }
    if (handlers.paths !== undefined) {
        for (const [path, pathOperations] of Object.entries(handlers.paths)) {
            for (const [method, handler] of Object.entries(pathOperations)) {
                if (handler === undefined)
                    continue;
                const newHandler = mapFunction(handler, { method: method, path });
                if (newHandler !== undefined) {
                    newHandlers = Object.assign(Object.assign({}, newHandlers), { paths: Object.assign(Object.assign({}, newHandlers.paths), { [path]: Object.assign(Object.assign({}, (_a = newHandlers === null || newHandlers === void 0 ? void 0 : newHandlers.paths) === null || _a === void 0 ? void 0 : _a[path]), { [method]: newHandler }) }) });
                }
            }
        }
    }
    if (handlers.default !== undefined) {
        const newHandler = mapFunction(handlers.default, 'default');
        if (newHandler !== undefined) {
            newHandlers.default = handlers.default;
        }
    }
    return newHandlers;
}
exports.mapOperationHandlers = mapOperationHandlers;
//# sourceMappingURL=utils.js.map